#Использовать "../src"
#Использовать asserts

#Область ПрограммныйИнтерфейс

Функция ПолучитьСписокТестов(Знач ЮнитТестирование) Экспорт

	ВсеТесты = Новый Массив;

	ВсеТесты.Добавить("ТестДолжен_ПроверитьСтроку_Пустую");
	ВсеТесты.Добавить("ТестДолжен_ПроверитьСтроку_СЗапятыми");
	ВсеТесты.Добавить("ТестДолжен_ПроверитьСтроку_СНеправильнымРазделителем");
	ВсеТесты.Добавить("ТестДолжен_ПроверитьСтроку_СТабами");
	ВсеТесты.Добавить("ТестДолжен_ПроверитьСтроку_СЗапятымиИДвойнымиКавычками");
	ВсеТесты.Добавить("ТестДолжен_ПроверитьСтроку_СЗапятымиИОдинарнымиКавычками");
	ВсеТесты.Добавить("ТестДолжен_ПроверитьСтроку_СЗапятымиИСмешаннымиКавычками");
	ВсеТесты.Добавить("ТестДолжен_ПроверитьСтроку_СПроизвольнымРазделителем");
	
	Возврат ВсеТесты;

КонецФункции

#Область Тесты

Процедура ТестДолжен_ПроверитьСтроку_Пустую() Экспорт

	ИсходнаяСтрока = "";

	результат = ЧтениеCSV.ИзСтроки(ИсходнаяСтрока);

	Ожидаем.Что(результат).ИмеетТип("Массив");
	Ожидаем.Что(результат).ИмеетДлину(0);

КонецПроцедуры

Процедура ТестДолжен_ПроверитьСтроку_СЗапятыми() Экспорт

	ИсходнаяСтрока = "0,1,2,3,4,5,6";

	результат = ЧтениеCSV.ИзСтроки(ИсходнаяСтрока); // Разделитель "," по умолчанию

	Ожидаем.Что(результат).ИмеетТип("Массив");
	Ожидаем.Что(результат).ИмеетДлину(7);

	Ожидаем.Что(результат[0]).Равно("0");
	Ожидаем.Что(результат[1]).Равно("1");
	Ожидаем.Что(результат[2]).Равно("2");
	Ожидаем.Что(результат[3]).Равно("3");
	Ожидаем.Что(результат[4]).Равно("4");
	Ожидаем.Что(результат[5]).Равно("5");
	Ожидаем.Что(результат[6]).Равно("6");

	ИсходнаяСтрока = "0,1,2,3,4,5,6";

	результат = ЧтениеCSV.ИзСтроки(ИсходнаяСтрока, ",");

	Ожидаем.Что(результат).ИмеетТип("Массив");
	Ожидаем.Что(результат).ИмеетДлину(7);

	Ожидаем.Что(результат[0]).Равно("0");
	Ожидаем.Что(результат[1]).Равно("1");
	Ожидаем.Что(результат[2]).Равно("2");
	Ожидаем.Что(результат[3]).Равно("3");
	Ожидаем.Что(результат[4]).Равно("4");
	Ожидаем.Что(результат[5]).Равно("5");
	Ожидаем.Что(результат[6]).Равно("6");

	ИсходнаяСтрока = "00, 11,22 , 33 ,	44	, 	55 	,	, ,";

	результат = ЧтениеCSV.ИзСтроки(ИсходнаяСтрока, ",");

	Ожидаем.Что(результат).ИмеетТип("Массив");
	Ожидаем.Что(результат).ИмеетДлину(9);

	Ожидаем.Что(результат[0]).Равно("00");
	Ожидаем.Что(результат[1]).Равно(" 11");
	Ожидаем.Что(результат[2]).Равно("22 ");
	Ожидаем.Что(результат[3]).Равно(" 33 ");
	Ожидаем.Что(результат[4]).Равно("	44	");
	Ожидаем.Что(результат[5]).Равно(" 	55 	");
	Ожидаем.Что(результат[6]).Равно("	");
	Ожидаем.Что(результат[7]).Равно(" ");
	Ожидаем.Что(результат[8]).Равно("");

КонецПроцедуры

Процедура ТестДолжен_ПроверитьСтроку_СНеправильнымРазделителем() Экспорт

	ИсходнаяСтрока = "0	1	2	3	4	5	6";

	результат = ЧтениеCSV.ИзСтроки(ИсходнаяСтрока); // Неправильный разделитель

	Ожидаем.Что(результат).ИмеетТип("Массив");
	Ожидаем.Что(результат).ИмеетДлину(1);

	Ожидаем.Что(результат[0]).Равно("0	1	2	3	4	5	6");
	
КонецПроцедуры

Процедура ТестДолжен_ПроверитьСтроку_СТабами() Экспорт

	ИсходнаяСтрока = "0	1	2	3	4	5	6";

	результат = ЧтениеCSV.ИзСтроки(ИсходнаяСтрока, "	");

	Ожидаем.Что(результат).ИмеетТип("Массив");
	Ожидаем.Что(результат).ИмеетДлину(7);

	Ожидаем.Что(результат[0]).Равно("0");
	Ожидаем.Что(результат[1]).Равно("1");
	Ожидаем.Что(результат[2]).Равно("2");
	Ожидаем.Что(результат[3]).Равно("3");
	Ожидаем.Что(результат[4]).Равно("4");
	Ожидаем.Что(результат[5]).Равно("5");
	Ожидаем.Что(результат[6]).Равно("6");

	ИсходнаяСтрока = "	1	 2	3 	,4,	5		7	";

	результат = ЧтениеCSV.ИзСтроки(ИсходнаяСтрока, "	"); // Разделитель "," по умолчанию

	Ожидаем.Что(результат).ИмеетТип("Массив");
	Ожидаем.Что(результат).ИмеетДлину(9);

	Ожидаем.Что(результат[0]).Равно("");
	Ожидаем.Что(результат[1]).Равно("1");
	Ожидаем.Что(результат[2]).Равно(" 2");
	Ожидаем.Что(результат[3]).Равно("3 ");
	Ожидаем.Что(результат[4]).Равно(",4,");
	Ожидаем.Что(результат[5]).Равно("5");
	Ожидаем.Что(результат[6]).Равно("");
	Ожидаем.Что(результат[7]).Равно("7");
	Ожидаем.Что(результат[8]).Равно("");

КонецПроцедуры

Процедура ТестДолжен_ПроверитьСтроку_СЗапятымиИДвойнымиКавычками() Экспорт

	разделитель = ",";

	значения = Новый Массив();

	значения.Добавить("");
	значения.Добавить("	");
	значения.Добавить("""" + """");
	значения.Добавить(""",""");
	значения.Добавить(" 	"",""4"",""	 ");
	значения.Добавить(Символы.ПС + Символы.ПС);
	значения.Добавить("Некоторая ""строка""");

	ПроверитьЗначения(значения, разделитель);

КонецПроцедуры

Процедура ТестДолжен_ПроверитьСтроку_СЗапятымиИОдинарнымиКавычками() Экспорт

	разделитель = ",";

	значения = Новый Массив();

	значения.Добавить("");
	значения.Добавить("	");
	значения.Добавить("''");
	значения.Добавить("','");
	значения.Добавить(" 	','4','	 ");
	значения.Добавить(Символы.ПС + Символы.ПС);
	значения.Добавить("Некоторая 'строка'");

	ПроверитьЗначения(значения, разделитель);

КонецПроцедуры

Процедура ТестДолжен_ПроверитьСтроку_СЗапятымиИСмешаннымиКавычками() Экспорт

	разделитель = ",";

	значения = Новый Массив();

	значения.Добавить("");
	значения.Добавить("	");
	значения.Добавить("'" + """" + "'");
	значения.Добавить("""" + "'" + """");
	значения.Добавить("""" + "'Кавычки' ""внутри"" 'кавычек'" + """");
	значения.Добавить("'" + "'Кавычки' ""внутри"" 'кавычек'" + "'");
	
	ПроверитьЗначения(значения, разделитель);

КонецПроцедуры

Процедура ТестДолжен_ПроверитьСтроку_СПроизвольнымРазделителем() Экспорт

	разделитель = "	Это сложный разделитель	";

	значения = Новый Массив(9);

	значения[0] = "";
	значения[1] = "	";
	значения[2] = ",";
	значения[3] = "3";
	значения[4] = " 	,4,	 ";
	значения[5] = Символы.ПС + Символы.ПС;
	значения[6] = "Это почти сложный разделитель";
	значения[7] = """" + разделитель + """, , """ + разделитель + """";
	значения[8] = "";

	ПроверитьЗначения(значения, разделитель);

КонецПроцедуры

#КонецОбласти

#КонецОбласти

#Область СлужебныеПроцедурыИФункции

Процедура ПроверитьЗначения(Знач Значения, Знач Разделитель)

	ИсходнаяСтрока = СтрСоединить(значения, разделитель);

	результат = ЧтениеCSV.ИзСтроки(ИсходнаяСтрока, разделитель);

	Ожидаем.Что(результат).ИмеетТип("Массив");
	Ожидаем.Что(результат).ИмеетДлину(значения.Количество());

	Для ц = 0 По значения.ВГраница() Цикл

		Ожидаем.Что(результат[ц]).Равно(значения[ц]);

	КонецЦикла;
	
КонецПроцедуры

#КонецОбласти